
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Atk.Structs.Implementor
    ( 

-- * Exported types
    Implementor(..)                         ,
    noImplementor                           ,


 -- * Methods
-- ** implementorRefAccessible
    implementorRefAccessible                ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Atk.Types
import GI.Atk.Callbacks

newtype Implementor = Implementor (ForeignPtr Implementor)
noImplementor :: Maybe Implementor
noImplementor = Nothing

-- method Implementor::ref_accessible
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Atk" "Implementor", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Atk" "Implementor", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Atk" "Object"
-- throws : False
-- Skip return : False

foreign import ccall "atk_implementor_ref_accessible" atk_implementor_ref_accessible :: 
    Ptr Implementor ->                      -- _obj : TInterface "Atk" "Implementor"
    IO (Ptr Object)


implementorRefAccessible ::
    (MonadIO m) =>
    Implementor ->                          -- _obj
    m Object
implementorRefAccessible _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- atk_implementor_ref_accessible _obj'
    checkUnexpectedReturnNULL "atk_implementor_ref_accessible" result
    result' <- (wrapObject Object) result
    touchManagedPtr _obj
    return result'


